using bdAntifraude.db;
using bdAntifraude.dbcontext;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using Serialize.Linq.Serializers;
using System.Diagnostics;
using System.Linq.Expressions;

namespace SwaggerAntifraude.Controllers
{
    [ApiController]
    [Route("api/[controller]")]
    public class RPT_DESCRIPController : GenericoController<RPT_DESCRIP, int>
    {
        public RPT_DESCRIPController()
             : base()
        {
        }


        [Authorize(Policy = "LecturaPolicy")]
        [HttpGet("{id}")]
        public override IActionResult GetById(int id)
        {
            try
            {
                using (var context = tsGestionAntifraude.NuevoContexto(SoloLectura: true, UseLazyLoadingProxies: false))
                {
                    //var dbSet = context.Set<VIDA_ADMINISTRATIVA>();
                    var entities = context.RPT_DESCRIP
                    .Include(rd => rd.IDRPTNavigation)
                    .Include(rd => rd.GRUPO1Navigation)
                    .Include(rd => rd.IDUNIDADADMINISTRATIVANavigation)
                        .AsNoTracking()
                        .FirstOrDefault(v => v.IDRPTDES == id);



                    if (entities == null)
                        return NotFound();

                    return Ok(entities);
                }
            }
            catch (Exception ex)
            {
                return StatusCode(500, $"Error interno del servidor: {ex.Message}");
            }
        }


        [Authorize(Policy = "LecturaPolicy")]
        [HttpGet("GetWithIncludes/{id}")]
        public async Task<IActionResult> GetWithIncludes(int id)
        {
            try
            {
                using (var context = tsGestionAntifraude.NuevoContexto(SoloLectura: true, UseLazyLoadingProxies: false))
                {
                    // Consulta con Includes necesarios
                    var entity = await context.RPT_DESCRIP
                    .Include(p => p.IDRPTNavigation) 
                    .Include(p => p.IDUNIDADADMINISTRATIVANavigation) 
                    .Include(p => p.CUERPO1Navigation) 
                    .Include(p => p.GRUPO1Navigation)
                    .Include(p => p.GRUPO2Navigation)
                    .Include(p => p.IDDEPARTAMENTONavigation)
                    .Include(p => p.ADSCRIPCIONNavigation)
                    .Include(p => p.PROVISIONNavigation) 
                    .AsNoTracking()
                    .Where(p => p.IDRPT == id).ToListAsync(); // Filtra por IDPUESTO

                    // Verifica si la entidad no se encontró
                    if (entity == null)
                        return NotFound($"El puesto con ID {id} no fue encontrado.");

                    // Devuelve la entidad con las relaciones cargadas
                    return Ok(entity);
                }
            }
            catch (Exception ex)
            {
                return StatusCode(500, $"Error interno del servidor: {ex.Message}");
            }
        }


        [Authorize(Policy = "LecturaPolicy")]
        [HttpGet("GetAtributo/{id}/{id2}")]
        public async Task<IActionResult> GetListRPTGrupo(int id, int id2)
        {
            try
            {
                using (var context = tsGestionAntifraude.NuevoContexto(SoloLectura: true, UseLazyLoadingProxies: false))
                {
                    // Consulta con Includes necesarios
                    var entity = await context.RPT_DESCRIP
                    .Include(p => p.GRUPO1Navigation)
                    .AsNoTracking()
                    .Where(p => p.IDRPT == id && p.GRUPO1 == id2).Select(x => x.CODIGO).ToListAsync(); // Filtra por IDPUESTO

                    // Verifica si la entidad no se encontró
                    if (entity == null)
                        return NotFound($"El puesto con ID {id} no fue encontrado.");

                    // Devuelve la entidad con las relaciones cargadas
                    return Ok(entity);
                }
            }
            catch (Exception ex)
            {
                return StatusCode(500, $"Error interno del servidor: {ex.Message}");
            }
        }


    }
}
